%define anolis_release 1

%undefine _package_note_flags

Name:           ocaml-luv
Version:        0.5.11
Release:        %{anolis_release}%{?dist}
Summary:        OCaml binding to libuv for cross-platform asynchronous I/O

License:        MIT
URL:            https://github.com/aantron/luv
Source0:        %{url}/releases/download/%{version}/luv-%{version}.tar.gz

BuildRequires:  ocaml >= 4.02.0
BuildRequires:  ocaml-alcotest-devel >= 0.8.1
BuildRequires:  ocaml-ctypes-devel >= 0.14.0
BuildRequires:  ocaml-dune >= 2.0.0
BuildRequires:  ocaml-result-devel
BuildRequires:  pkgconfig(libuv)

%description
Luv is a binding to libuv, the cross-platform C library that does
asynchronous I/O in Node.js and runs its main loop.

Besides asynchronous I/O, libuv also supports multiprocessing and
multithreading.  Multiple event loops can be run in different threads.
Libuv also exposes a lot of other functionality, amounting to a full OS
API, and an alternative to the standard module Unix.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       ocaml-ctypes-devel
Requires:       ocaml-result-devel

%description    devel
The %{name}-devel package contains libraries and signature
files for developing applications that use %{name}.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n luv-%{version}

# Remove spurious executable bits
find . -type f -exec chmod 0644 {} +

%build
export LUV_USE_SYSTEM_LIBUV=yes
%dune_build

cd _build/default/src/c
ocamlmklib -g -ldopt "%{build_ldflags}" -o luv_c_stubs \
  $(ar t libluv_c_stubs.a) -luv
cd -
cd _build/default/src/unix
ocamlmklib -g -ldopt "%{build_ldflags}" -o luv_unix_stubs \
  $(ar t libluv_unix_stubs.a)
cd -

%install
export LUV_USE_SYSTEM_LIBUV=yes
%dune_install
%generate_compatibility_deps

%check
export LUV_USE_SYSTEM_LIBUV=yes
%dune_check

%files -f .ofiles
%license LICENSE.md
%dir %{abidir}
%{abidir}/dllluv_c_stubs.dump
%{abidir}/dllluv_unix_stubs.dump

%files devel -f .ofiles-devel

%files doc
%doc README.md

%changelog
* Sat Mar 25 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 0.5.11-1
- Init from upstream
